<template>
  <v-card card-body-class="px-0">
    <div class="px-4 mb-2">
      <input
        class="form-control search-input"
        type="text"
        placeholder="Search..."
        aria-label="search"
        v-model="searchValue"
      />
    </div>
    <div v-if="loading" class="text-center">
      <v-spinner />
    </div>
    <v-alert v-else-if="error" />
    <v-table
      v-else
      :items="filteredBusStops"
      :headers="[{ title: 'Bus Stops' }]"
    >
      <template #row="{ item }">
        <td>{{ item }}</td>
      </template>
    </v-table>
  </v-card>
</template>

<script setup lang="ts">
import VCard from '@/ui/v-card/VCard.vue';
import VTable from '@/ui/v-table/VTable.vue';
import VSpinner from '@/ui/v-spinner/VSpinner.vue';
import VAlert from '@/ui/v-alert/VAlert.vue';
import { ref, computed } from 'vue';

const props = defineProps<{
  busStops: Array<string>;
  loading: boolean;
  error: boolean;
}>();

const filteredBusStops = computed(() => {
  if (!searchValue.value) {
    return props.busStops;
  }
  return props.busStops.filter((item) => {
    return item
      .toLocaleLowerCase()
      .includes(searchValue.value.toLocaleLowerCase());
  });
});

const searchValue = ref('');
</script>

<style scoped></style>
